/// Generated By XFlutter Cli.
/// 
/// more info: https://medium.com/@aghiadodeh
import 'package:animated_infinite_scroll_pagination/animated_infinite_scroll_pagination.dart';
import 'package:flutter/material.dart';
import 'package:flutter_mvvm_example/config/singleton_config.dart';
import 'package:flutter_mvvm_example/ui/core/layouts/base_scroll_view.dart';
import 'pagination_load_widget.dart';
import 'pagination_error_widget.dart';
import '../loaders/loader.dart';
import '../animations/customized_animated_widget.dart';

/// [VM] a view model extends [PaginationViewModel]
/// [T] the Model of item
class InfiniteScrollView<VM extends PaginationViewModel<T>, T extends Object> extends StatelessWidget {
  /// [itemBuilder] callback return [Widget] with item [T].
  final Widget Function(T) itemBuilder;

  /// [onRefresh] callback called when user swipe to refresh list.
  final Function()? onRefresh;

  /// [retry] callback called when pagination request faild and user press on [PaginationErrorWidget].
  final Function()? retry;
  const InfiniteScrollView({
    required this.itemBuilder,
    this.onRefresh,
    this.retry,
    Key? key,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return AnimatedInfiniteScrollView<T>(
      viewModel: getSingleton<VM>(),
      refreshIndicator: true,
      loadingWidget: const CustomizedAnimatedWidget(child: Loader()),
      footerLoadingWidget: const PaginationLoaderWidget(),
      errorWidget: const PaginationErrorWidget(),
      physics: scrollPhysics,
      onRefresh: onRefresh,
      itemBuilder: (item) => CustomizedAnimatedWidget(child: itemBuilder.call(item)),
    );
  }
}
